package	jp.co.sds_corp.tool.photolist;

import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;

import javax.imageio.ImageIO;

public class Thumb
{
	String	ext;
	String	dir;
	File	src;
	int		width;
	int		height;
	File	result;
	String	name;

	public Thumb() {
	}

	public void setExt( String var ) {
		this.ext = var;
	}

	public void setDir( String var ) {
		this.dir = var;
	}

	public void setSource( File var ) {
		this.src = var;
	}

	public void setWidth( int var ) {
		this.width = var;
	}

	public void setHeight( int var ) {
		this.height = var;
	}

	public File getResult() {
		return result;
	}
	public String getResultName() {
		return name;
	}

	public boolean createThumb( File file ) throws Exception {
		this.src = file;
		return createThumb();
	}

	public boolean createThumb() throws Exception {
		BufferedImage bi = ImageIO.read( src );
		if ( bi == null ) {
			return false;
		}
		double dDiv = (double )width / bi.getWidth();

		BufferedImage buf = new BufferedImage(
									width, (int )(bi.getHeight() * dDiv ),
									BufferedImage.TYPE_INT_RGB );

		Graphics2D gr = buf.createGraphics();
		AffineTransform at = new AffineTransform();
		at.setToScale( dDiv, dDiv );
//		at.setToScale( (double )nWidth / bi.getWidth(), (double )nHeight / bi.getHeight() );

		gr.drawImage( bi, at, null );

		name = src.getName();
		int nIdx = name.lastIndexOf( "." );
		if ( nIdx > 0 ) {
			name = name.substring( 0, nIdx );
		}
		name = name + "." + ext;
		result = new File( dir + "/" + name );
		ImageIO.write( buf, ext, result );

		return true;
	}

/*
	public boolean createThumb() throws Exception {
		JimiReader rd;
		try {
			rd = Jimi.createJimiReader( src.getPath() );
		} catch ( Exception e ) {
			return false;
		}
		Dimension dim = rd.getSize();
		double dDiv = (double )width / dim.getWidth();

		BufferedImage buf = new BufferedImage(
									width, (int )(dim.getHeight() * dDiv ),
									BufferedImage.TYPE_INT_RGB );

		Graphics2D gr = buf.createGraphics();
		AffineTransform at = new AffineTransform();
		at.setToScale( dDiv, dDiv );

		gr.drawImage( rd.getImage(), at, null );
		JimiImage jImg = Jimi.createRasterImage( buf.getSource() );
		rd.close();

		result = new File( dir + "/" + src.getName() + ".jpeg" );
		FileOutputStream out = new FileOutputStream( result );
		Jimi.putImage( mime, jImg, out );

		out.flush();
		out.close();

		return true;
	}
*/

	public static void main( String[] args ) {
		try {
			Thumb obj = new Thumb();
			obj.setDir( "Thumb" );
			obj.setExt( "png" );
			obj.setWidth( 100 );

			for ( int i = 0; i < args.length; i++ ) {
				System.out.print( args[i] + " ... " );
				obj.createThumb( new File( args[i] ));
				System.out.print( obj.getResult() );
			}
		} catch ( Exception e ) {
			e.printStackTrace();
		}
	}
}
